lightoj1037_状压dp

题目链接:http://lightoj.com/volume_showproblem.php?problem=1037

题意:你现在需要消灭n个敌人,n个敌人的血量已知,你的普通攻击力为1,但是如果你杀死敌人i可以用它的武器去杀死其他敌人,b[i][j] 表示用敌人i的武器射杀敌人j会减b[i][j]滴血.问你最少可以攻击多少次可以将敌人杀死。

思路:

定义集合s为死亡敌人的集合。

dp[s] 为让集合为s的人死亡最小需要的攻击次数。

如果现在想要消灭敌人i 并且敌人i不属于s

那么dp[s | (1<<i)] = min(dp[s|(1<<i)] , dp[s] + t);

t 为用死亡敌人的武器消灭敌人i的最小费用。如何求t成为了本题的关键。

考虑死亡敌人集合s,你同样也拥有了死亡敌人j的武器【j属于集合s】

那么t =  min(t, 用敌人j 的武器射杀i的次数) 【j属于集合s】

当t一次都没有被更新时,说明死亡敌人的武器没有可以消灭敌人i的,只能用普通武器攻击

 1 #include <algorithm>
 2 #include <iostream>
 3 #include <cstring>
 4 #include <cstdlib>
 5 #include <cstdio>
 6 #include <vector>
 7 #include <ctime>
 8 #include <queue>
 9 #include <list>
10 #include <set>
11 #include <map>
12 using namespace std;
13 #define INF 0x3f3f3f3f
14 typedef long long LL;
15
16 int a[20], b[20][20], x[20], y[20];
17 int dp[20][1<<15];
18 char bb[20][20];
19 int main()
20 {
21     int t, n;
22     scanf("%d", &t);
23     for(int ca = 1; ca <= t; ca++)
24     {
25         scanf("%d", &n);
26         for(int i = 1; i <= n ; i++)
27             scanf("%d", &a[i]);
28         for(int i = 1; i <= n; i++)
29             scanf("%s", bb[i]);
30         for(int i = 1; i <= n; i++)
31             for(int j = 0; j < n; j++)
32                 b[i][j+1] = bb[i][j] - ‘0‘;
33         memset(dp, INF, sizeof(dp));
34         for(int i = 0; i < n; i++)
35             dp[1][1<<i] = a[i+1];
36         for(int i = 2; i <= n; i++)
37         {
38             for(int j = 1; j < (1 << n); j++)
39             {
40                 int te = j;
41                 int l1 = 0, l2 = 0, l3 = 0;
42                 while(te)
43                 {
44                     if(te % 2)
45                         x[++l1] = l3;//1
46                     else
47                         y[++l2] = l3;//0
48                     te >>= 1;
49                     l3++;
50                 }
51                 while(l3 < n)
52                 {
53                     y[++l2] = l3;
54                     l3++;
55                 }
56                 if(l1 != i-1)
57                     continue;
58                 for(int k1 = 1; k1 <= l2; k1++)//0, l2, y
59                 {
60                     int tx = 0;
61                     for(int k2 = 1; k2 <= l1; k2++)//1, l1, x
62                     {
63                         if(b[x[k2]+1][y[k1]+1] > tx)
64                         {
65                             tx = b[x[k2]+1][y[k1]+1];
66                         }
67                     }
68                     if(tx == 0)
69                         dp[i][j|(1<<y[k1])] = min(dp[i][j|(1<<y[k1])], dp[i-1][j] + a[y[k1]+1]);
70                     else if(a[y[k1]+1] % tx)
71                         dp[i][j|(1<<y[k1])] = min(dp[i][j|(1<<y[k1])], dp[i-1][j] + a[y[k1]+1] / tx + 1);
72                     else if(a[y[k1]+1] % tx == 0)
73                         dp[i][j|(1<<y[k1])]= min(dp[i][j|(1<<y[k1])], dp[i-1][j] + a[y[k1]+1] / tx);
74                 }
75             }
76         }
77         int res = dp[n][(1<<n)-1];
78         printf("Case %d: %d\n", ca, res);
79     }
80     return 0;
81 }
时间: 2024-12-26 10:54:45

lightoj1037_状压dp的相关文章

ZOJ3305Get Sauce 状压DP,

状压DP的题目留个纪念,首先题意一开始读错了,搞了好久,然后弄好了,觉得DFS可以,最后超时,修改了很久还是超时,没办法看了一下n的范围,然后觉得状压可以,但是没有直接推出来,就记忆化搜索了一下,可是一直错,莫名奇妙,然后没办法看了一下题解,发现了下面这个比较好的方法,然后按照这个方程去推,然后敲,也是WA了好多把,写的太搓了,没人家的清楚明了,唉~也算是给自己留个纪念,状压一直做的都不太好~唉~还好理解了, 参考了  http://blog.csdn.net/nash142857/articl

poj 2411 Mondriaan&#39;s Dream(状压DP)

Mondriaan's Dream Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 12232   Accepted: 7142 Description Squares and rectangles fascinated the famous Dutch painter Piet Mondriaan. One night, after producing the drawings in his 'toilet series

(状压dp)uva 10817 Headmaster&#39;s Headache

题目地址 1 #include <bits/stdc++.h> 2 typedef long long ll; 3 using namespace std; 4 const int MAX=1e5+5; 5 const int INF=1e9; 6 int s,m,n; 7 int cost[125]; 8 //char sta[MAX]; 9 string sta; 10 int able[125]; 11 int dp[125][1<<8][1<<8]; 12 in

HDU5816 Hearthstone(状压DP)

题目 Source http://acm.hdu.edu.cn/showproblem.php?pid=5816 Description Hearthstone is an online collectible card game from Blizzard Entertainment. Strategies and luck are the most important factors in this game. When you suffer a desperate situation an

HDU 4336 容斥原理 || 状压DP

状压DP :F(S)=Sum*F(S)+p(x1)*F(S^(1<<x1))+p(x2)*F(S^(1<<x2))...+1; F(S)表示取状态为S的牌的期望次数,Sum表示什么都不取得概率,p(x1)表示的是取x1的概率,最后要加一因为有又多拿了一次.整理一下就可以了. 1 #include <cstdio> 2 const int Maxn=23; 3 double F[1<<Maxn],p[Maxn]; 4 int n; 5 int main() 6

Travel(HDU 4284状压dp)

题意:给n个城市m条路的网图,pp在城市1有一定的钱,想游览这n个城市(包括1),到达一个城市要一定的花费,可以在城市工作赚钱,但前提有工作证(得到有一定的花费),没工作证不能在该城市工作,但可以走,一个城市只能工作一次,问pp是否能游览n个城市回到城市1. 分析:这个题想到杀怪(Survival(ZOJ 2297状压dp) 那个题,也是钱如果小于0就挂了,最后求剩余的最大钱数,先求出最短路和 Hie with the Pie(POJ 3311状压dp) 送披萨那个题相似. #include <

BZOJ 1087: [SCOI2005]互不侵犯King( 状压dp )

简单的状压dp... dp( x , h , s ) 表示当前第 x 行 , 用了 h 个 king , 当前行的状态为 s . 考虑转移 : dp( x , h , s ) = ∑ dp( x - 1 , h - cnt_1( s ) , s' ) ( s and s' 两行不冲突 , cnt_1( s ) 表示 s 状态用了多少个 king ) 我有各种预处理所以 code 的方程和这有点不一样 ------------------------------------------------

BZOJ 1072 排列 状压DP

题意:链接 方法:状压DP? 题解:这题其实没啥好写的,不算很难,推一推就能搞出来. 首先看到这个问题,对于被d整除这个条件,很容易就想到是取余数为0,所以想到可能状态中刚开始含有取余数. 先说我的第一个想法,f[i][j]表示选取i个数且此时的mod为j,这样的思想是第一下蹦出来的,当时想的就是在线来搞最终的答案.不过转瞬即发现,这TM不就是暴力吗魂淡!并没有什么卵用,于是开始想这个状态可不可以做什么优化. 显然第二维的j并不需要太大的优化,暂且先将其搁置一边,来考虑第一维的i怎么优化. 把滚

COdeforces#417D Cunning Gena(状压DP)

A boy named Gena really wants to get to the "Russian Code Cup" finals, or at least get a t-shirt. But the offered problems are too complex, so he made an arrangement with his n friends that they will solve the problems for him. The participants